//
// TinyPTC with DirectDraw
//
// MIRACLE #2 win32 remake
// Amiga Classic Compo/DBFInteractive.com
//
// remake by VrS!
// original code by Sabbath
// original gfx by ??
// original Sid2 music 'romeo_knight_II' - remix by TIP/DualCrew

#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <ctime>
#include "tinyptc.h"
#include "resource.h"
#include "main.h"
#include "mus.h" // which player

#define BtStart 500 // identificateur pour bouton 1
#define Quitter 501 // identificateur pour bouton 2
#define BtHires 502
#define BtLores 503
#define BWindow 504
#define BFullsc 505

HINSTANCE hInstance;
HWND hstatic;

extern "C" int ptc_open(char *title,int width,int height);
extern "C" int ptc_update(void *buffer);
extern "C" void stopzic();

// if soundmon player - module is on a cpp file (default music.cpp)
// multithread
#ifdef BP
#pragma comment(lib,"dsound.lib")
#include "soundmon\Modplayer.h"
#pragma comment(linker, "/nodefaultlib:libcmt.lib")	//
// module vendetta.cpp or synthdrum.cpp
#endif

// if Ahx player
#ifdef AHX
#include "ahx/windows.h"
#include "ahx/ahx.h"
#include "ZYRIAX.H" // module
#endif

// if uFmod
#ifdef UFMOD
#include <mmsystem.h>
#include "ufmod.h"
//#pragma comment(linker, "/nodefaultlib:libc.lib")	// msvcrt.lib (Multithreaded mode)
#pragma comment(linker, "/nodefaultlib:libcmt.lib")	//
#include "MONSTER.H"			// include module bin as .h unsigned char tab
HWAVEOUT* hWave = 0;
#endif

// if MiniFmod
#ifdef MINIFMOD
// minifmod include & lib
#include "minifmod.h"
#pragma comment(lib,"minifmod.lib")
#pragma comment(linker, "/nodefaultlib:libc.lib")
#include "MONSTER.H" // module

//-------------------------- MINIFMOD -------------------------*
// module struct
typedef struct 
{
	int length;
	int pos;
	void *data;
} MEMFILE;

FMUSIC_MODULE *pModule;

unsigned int memopen(char *name)
{
	MEMFILE *memfile;

	memfile = (MEMFILE *)calloc(sizeof(MEMFILE),1);

	memfile->length = sizeof(music);
	memfile->data = malloc(memfile->length);
	memfile->pos = 0;
	memcpy(memfile->data,music,memfile->length);

	return (unsigned int)memfile;
}

void memclose(unsigned int handle)
{
	MEMFILE *memfile = (MEMFILE *)handle;
	free(memfile->data);
}

int memread(void *buffer, int size, unsigned int handle)
{
	MEMFILE *memfile = (MEMFILE *)handle;

	if (memfile->pos + size >= memfile->length)
		size = memfile->length - memfile->pos;

	memcpy(buffer, (char *)memfile->data+memfile->pos, size);
	memfile->pos += size;
	
	return size;
}

void memseek(unsigned int handle, int pos, signed char mode)
{
	MEMFILE *memfile = (MEMFILE *)handle;

	if (mode == SEEK_SET) 
		memfile->pos = pos;
	else if (mode == SEEK_CUR) 
		memfile->pos += pos;
	else if (mode == SEEK_END)
		memfile->pos = memfile->length + pos;

	if (memfile->pos > memfile->length)
		memfile->pos = memfile->length;
}

int memtell(unsigned int handle)
{
	MEMFILE *memfile = (MEMFILE *)handle;

	return memfile->pos;
}
#endif // ifdef minifmod

//------------------------------------------------------------

// Function declares
void Cls(int rgb);
void WritePixel(int x,int y,int rgb);
//
void stopzic();
void initSize();
void initfx();
void render_effect();
void DrawImage(unsigned char* img,int xpos,int ypos,int sx, int sy);
void DrawImagef(unsigned char* img,int xpos,int ypos,int sx, int sy);
void DrawImage2(unsigned char* img,int xpos,int ypos,int sx, int sy);

#ifdef AHX
static bool tune_init(const char *);
static bool tune_init2(void);
static void tune_play(void);
static void tune_stop(void);
static void tune_start(void);
static void tune_shutdown(void);
#endif

#ifdef BP
extern void StopMod();
extern void LoadMod(char *buf,HWND hWnd);
#endif
//-----------------------------------------------------------------
// Our Functions
//-----------------------------------------------------------------
#define ORIGINAL
#include "logo256_raw.h"
#include "logo256_pal.h"
#include "back_raw.h"
#include "back_pal.h"
#ifndef ORIGINAL
	#include "fore2_raw.h"	// 384*2*240 mask
	#include "fore2_pal.h"
#else
	#include "fore256_raw.h" // 32*149 mask
	#include "fore256_pal.h"
#endif

int ZOOM=2;
int WIDTH=320;
int HEIGHT=240;
#define SIZE 640*480
extern "C" BOOL fullscreen;
BOOL butquit=FALSE;
// Setup a buffer for our reading and writing (FrameBuffer)
static int buffer[SIZE];
//----------- draw bitmap 
#ifdef WRITER
	#include "FX/Scrolls.h"
	#include "FX/Writers2.h"
#endif

// var bitmap
int logox=320;
int logoy=54;
int logoposx=0;
int backx=384*2;
int backy=240;
int xposback=384;
#ifndef ORIGINAL
	int xforeground = 384;
	int wforeground = 384*2; 
#else
	int xforeground = 190;
	int wforeground = 32; 
#endif
int yforeground = 74;
int hforeground = 149;

unsigned char* ptlogo;
unsigned char* ptback;
unsigned char* ptfore;
unsigned char logo_r[256],logo_g[256],logo_b[256];
unsigned char back_r[256],back_g[256],back_b[256];
unsigned char fore_r[256],fore_g[256],fore_b[256];
unsigned char TabMov[]= {  
 0x50,0x50,0x50,0x50,0x50,0x50,0x50,0x4f,0x4f,0x4f,0x4f,0x4f,0x4e,0x4e,0x4e,
 0x4d,0x4d,0x4d,0x4c,0x4c,0x4b,0x4b,0x4a,0x4a,0x49,0x49,0x48,0x48,0x47,0x46,
 0x46,0x45,0x44,0x44,0x43,0x42,0x41,0x41,0x40,0x3f,0x3e,0x3d,0x3d,0x3c,0x3b,
 0x3a,0x39,0x38,0x37,0x36,0x35,0x35,0x34,0x33,0x32,0x31,0x30,0x2f,0x2e,0x2d,
 0x2c,0x2b,0x2a,0x29,0x28,0x27,0x26,0x25,0x24,0x23,0x22,0x21,0x20,0x1f,0x1e,
 0x1d,0x1c,0x1b,0x1b,0x1a,0x19,0x18,0x17,0x16,0x15,0x14,0x13,0x13,0x12,0x11,
 0x10,0x0f,0x0f,0x0e,0x0d,0x0c,0x0c,0x0b,0x0a,0x0a,0x09,0x08,0x08,0x07,0x07,
 0x06,0x06,0x05,0x05,0x04,0x04,0x03,0x03,0x03,0x02,0x02,0x02,0x01,0x01,0x01,
 0x01,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
 0x01,0x01,0x01,0x01,0x01,0x02,0x02,0x02,0x03,0x03,0x03,0x04,0x04,0x05,0x05,
 0x06,0x06,0x07,0x07,0x08,0x08,0x09,0x0a,0x0a,0x0b,0x0c,0x0c,0x0d,0x0e,0x0f,
 0x0f,0x10,0x11,0x12,0x13,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1b,
 0x1c,0x1d,0x1e,0x1f,0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2a,
 0x2b,0x2c,0x2d,0x2e,0x2f,0x30,0x31,0x32,0x33,0x34,0x35,0x35,0x36,0x37,0x38,
 0x39,0x3a,0x3b,0x3c,0x3d,0x3d,0x3e,0x3f,0x40,0x41,0x41,0x42,0x43,0x44,0x44,
 0x45,0x46,0x46,0x47,0x48,0x48,0x49,0x49,0x4a,0x4a,0x4b,0x4b,0x4c,0x4c,0x4d,
 0x4d,0x4d,0x4e,0x4e,0x4e,0x4f,0x4f,0x4f,0x4f,0x4f,0x50,0x50,0x50,0x50,0x50,
 0x50};
//-----------------------------------------------
//-                   MAIN						-
//-----------------------------------------------
LRESULT CALLBACK DialogProc(HWND Dlg,UINT message,WPARAM wParam,LPARAM lParam);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
//int main()
{
	DWORD Temps_Ecoule=0;	//permet de synchroniser les FPS (images par seconde)
	int quit;
	timeBeginPeriod(1);
//-------------------------------------
//	Dialog Box Indirect sans resource -
//-------------------------------------
    HGLOBAL hmem; //handle mmoire globale
    LPDLGTEMPLATE lpdt; //pointeur sur structure dialog template
    LPWORD lpw; // pointeur sur un WORD
    LPWSTR lpnom; // pointeur sur chaine UNICODE pour le nom de la boite
    
    //allouer de la mmoire  pour notre dialog template
    hmem = GlobalAlloc(GPTR, 512); //GPTR=taille fixe initialise  0
    if (!hmem) return 1;

    //convertir le handle en pointeur DLGTEMPLATE sur le dbut de la mmoire alloue  
    lpdt = ( LPDLGTEMPLATE) hmem;

    // Dfinir les proprits de la boite de dialogue
    lpdt->style = WS_POPUP | WS_BORDER | DS_CENTER |WS_MINIMIZEBOX| WS_SYSMENU | DS_MODALFRAME | WS_CAPTION;
    lpdt->x = 0;   //position x
    lpdt->y = 0;   //position y
    lpdt->cx = 180; //largeur
    lpdt->cy = 60; //hauteur
	//obtenir pointeur juste aprs la structure DLGTEMPLATE
    lpw = (LPWORD) (lpdt + 1);
    
    //obtenir pointeur sur la zone du nom de la boite de dialogue
    lpnom = (LPWSTR) lpw+2;

    //convertir le nom en UNICODE et le mettre dans la zone nom
    MultiByteToWideChar (CP_ACP, 0, "Amiga Cracktros Remakes", -1, lpnom, 128);

    // lancer la boite de dialogue
    DialogBoxIndirect(hInstance,lpdt,NULL,(DLGPROC)DialogProc);

    // libration de la mmoire alloue
    GlobalFree(hmem);
//---
	if(butquit) return 0;

	initSize();
	// Open our window/screen
    if (!ptc_open("VrS! HORIZON #2 REMAKE",WIDTH,HEIGHT)) return 1;

#ifdef MINIFMOD
	// init FMOD
	FSOUND_File_SetCallbacks(memopen, memclose, memread, memseek, memtell);
	pModule = FMUSIC_LoadSong( (char*)music, NULL ); //sampleloadcallback;

	if (!pModule)
	{
		MessageBox(NULL,"module not found","FMOD error",MB_OK);
		return 0;		// Quit the program
	}
	FMUSIC_PlaySong(pModule); // start music	
#endif

#ifdef UFMOD
	hWave = uFMOD_PlaySong((char*)music,(void*)music_length,XM_MEMORY);
#endif

#ifdef AHX
	tune_init2();
	tune_start();
#endif

	initfx();

	// main loop exit
/*    while (1)
    {
		//on lance l'affichage en synchronisant les FPS
		if (timeGetTime()-Temps_Ecoule>=(1000/60))	//60 fps (1000 ms /16.6 ms)
		{
			Temps_Ecoule=timeGetTime();
			render_effect();
		}
    }
*/
	quit = 0;
	do
	{
		MSG msg;
		while (PeekMessage(&msg,NULL,0,0, PM_NOREMOVE))
		{
			if (GetMessage(&msg,NULL,0,0)>0)
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
			else
			{
				quit = 1;
				break;
			}
		}

		//on lance l'affichage en synchronisant les FPS
		if (timeGetTime()-Temps_Ecoule>=(1000/60))	//60 fps (1000 ms /16.6 ms)
		{
			Temps_Ecoule=timeGetTime();
			render_effect();
		}
	} while (!quit);

	stopzic();

	return 0;
}

//-----------------------------------------
void initSize(void)
{
	WIDTH*=ZOOM;
	HEIGHT*=ZOOM;
	#ifdef WRITER
	WRITERSTARTX*=ZOOM;
	WRITERSTARTY*=ZOOM;
	#endif
	ptfont=font1;
	ptfont2=font2;
	SINAMPL*=ZOOM;
	ptlogo=logo_raw;
	ptback=back_raw;
	ptfore=fore_raw;
}

void initfx()
{
	int i;
	#ifdef WRITER
	InitWriter();
	#endif
	#ifdef SCROLLTXT
	InitSinus();
	#endif

    for(i=0;i<255;i++)
	{
         //Palette array name
         logo_r[i] = logo_pal[i*3];
         logo_g[i] = logo_pal[i*3+1];
         logo_b[i] = logo_pal[i*3+2];
         back_r[i] = back_pal[i*3];
         back_g[i] = back_pal[i*3+1];
         back_b[i] = back_pal[i*3+2];
         fore_r[i] = fore_pal[i*3];
         fore_g[i] = fore_pal[i*3+1];
         fore_b[i] = fore_pal[i*3+2];
    }
}

void render_effect()
{
	Cls(0); // clear screen
	DrawImage(ptback,xposback,0,WIDTH/ZOOM,backy); // background
	#ifdef WRITER
		DoWriter();
	#endif
	#ifdef SCROLLTXT
		DoScrollText();
	#endif
	#ifndef ORIGINAL
		DrawImagef(ptfore,xforeground,yforeground*ZOOM,WIDTH/ZOOM,hforeground); // foreground  
	#else
		DrawImagef(ptfore,xforeground*ZOOM,yforeground*ZOOM,wforeground,hforeground);
	#endif

	DrawImage2(ptlogo,0,12*ZOOM,logox,logoy); // logo

    xposback-=2*ZOOM;
	#ifndef ORIGINAL
		xforeground=xforeground-2*ZOOM;
	#else
		xforeground=xforeground+2*ZOOM;
	#endif
    if(xposback<0)
	{
        xposback=384;
		#ifndef ORIGINAL
			xforeground=384;
		#else
			xforeground=190;
		#endif
    }   
	#ifdef ORIGINAL
		if(xforeground>WIDTH/ZOOM) xforeground=-wforeground*2+2;
	#endif
    logoposx+=4;//*ZOOM;
    if(logoposx>255) logoposx=0;

	ptc_update(buffer); // update screen with DDraw
}
//--------------------------------------------
// Common Functions
//--------------------------------------------
void stopzic()
{
	#ifdef MINIFMOD
	FMUSIC_StopSong(pModule);
	FMUSIC_FreeSong(pModule);
	#endif
	#ifdef UFMOD
    uFMOD_StopSong();
	#endif
	#ifdef AHX
//	tune_stop();
	tune_shutdown();
	#endif
	#ifdef BP
	StopMod();
	#endif
	timeEndPeriod(1);
}

// clear screen
void Cls(int rgb)
{
	int x;
	int y;
	//Do cls stuff
	for (y=0; y<HEIGHT; y++)
	{
		for (x=0; x<WIDTH; x++)
		{
            buffer[(y*WIDTH+x)] =rgb;
		}
	}
}

// plot a pixel
void WritePixel(int x,int y,int rgb)
{
	//Do write pixel
	if(x>-1)
	{
		if(x<WIDTH)
		{
			if(y>-1)
			{
				if(y<HEIGHT)
				{
					buffer[(y*WIDTH+x)] =rgb;
				}
			}
		}
	}
}

// to do: mix the 2 routines in one
// background
void DrawImage(unsigned char* img,int xpos,int ypos,int sx, int sy)
{
    int x,y,pixel,col,txp=0,typ=0;
    
    for(y=0;y<sy;y++)
	{
		txp=0;
        for(x=0;x<sx;x++)
		{
            pixel = *(img+x+xpos+y*backx);
			col=RGB(back_b[pixel],back_g[pixel],back_r[pixel]);

			if(pixel!=0)
			{
				WritePixel( txp,typ+ypos, col);
				if(ZOOM==2)
				{
					WritePixel( txp+1,typ+ypos, col);
					WritePixel( txp+1,typ+ypos+1, col);
					WritePixel( txp,typ+ypos+1, col);
				}
			}
			txp+=ZOOM;
		}
		typ+=ZOOM;
	} 
}
// foreground
void DrawImagef(unsigned char* img,int xpos,int ypos,int sx, int sy)
{
    int x,y,pixel,col,txp=0,typ=0;
    
    for(y=0;y<sy;y++)
	{
		txp=0;
        for(x=0;x<sx;x++)
		{
			#ifdef ORIGINAL
            if((txp+xpos<WIDTH) && (txp+xpos>=0))
			{
				pixel = *(img+x+y*wforeground);
			#else
				pixel = *(img+x+xpos+y*wforeground);
			#endif
			col=RGB(fore_b[pixel],fore_g[pixel],fore_r[pixel]);
			if(pixel==0) col=0x111111;
			if(pixel!=93)
			{
				#ifdef ORIGINAL
				WritePixel( txp+xpos,typ+ypos, col);
				if(ZOOM==2)
				{
					WritePixel( txp+xpos+1,typ+ypos, col);
					WritePixel( txp+xpos+1,typ+ypos+1, col);
					WritePixel( txp+xpos,typ+ypos+1, col);
				}
				#else
				WritePixel( txp,typ+ypos, col);
				if(ZOOM==2)
				{
					WritePixel( txp+1,typ+ypos, col);
					WritePixel( txp+1,typ+ypos+1, col);
					WritePixel( txp,typ+ypos+1, col);
				}
				#endif
			}
			#ifdef ORIGINAL
			}
			#endif
			txp+=ZOOM;
		}
		typ+=ZOOM;
	} 
}// logo
void DrawImage2(unsigned char* img,int xpos,int ypos,int sx, int sy)
{
    int x,y,pixel,col,txp=0,typ=0,mx,vsx;
    mx=TabMov[logoposx]/2;
    vsx=sx-TabMov[logoposx];
    
    for(y=0;y<sy;y++)
	{
		txp=0;
        for(x=0;x<vsx;x++)
		{
            pixel = *(img+x+mx+y*sx);
			col=RGB(logo_b[pixel],logo_g[pixel],logo_r[pixel]);

			if(pixel!=0)
			{
				WritePixel( txp+xpos,typ+ypos, col);
				if(ZOOM==2)
				{
					WritePixel( txp+xpos+1,typ+ypos, col);
					WritePixel( txp+xpos+1,typ+ypos+1, col);
					WritePixel( txp+xpos,typ+ypos+1, col);
				}
			}
			txp+=ZOOM;
		}
		typ+=ZOOM;
	} 
}

//--------------------------------------------- AHX
#ifdef AHX
static AHXPlayer *player;
static AHXWaveOut *output;

static bool tune_init2(void)
{
	player = new AHXPlayer;
	player->Init(NULL);
	if (player->LoadSong((char *)music,music_length))
	{
		player->InitSubsong(0);
		output = new AHXWaveOut;
		output->Init();
		output->Play(player);
		return true;
	}
	else
	{
		delete player;
		player = NULL;
		return false;
	}
}

static bool tune_init(const char *fname)
{
	player = new AHXPlayer;
	player->Init(NULL);
	if (player->LoadSong((char *)fname))
	{
		player->InitSubsong(0);
		output = new AHXWaveOut;
		output->Init();
		output->Play(player);
		return true;
	}
	else
	{
		delete player;
		player = NULL;
		return false;
	}
}

static void tune_play(void)
{
	Sleep(1000/60);
}

static void tune_shutdown(void)
{
	if (output)
	{
		output->StopBackgroundPlay();
		delete output;
		output = NULL;
	}
	if (player)
	{
		delete player;
		player = NULL;
	}
}

static void tune_start(void)
{
	output->StartBackgroundPlay();
}

static void tune_stop(void)
{
	output->StopBackgroundPlay();
}

#endif

LRESULT CALLBACK WindowProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg )
	{
		case WM_KEYDOWN:
			switch (wParam)
			{
				case VK_ESCAPE:
					PostQuitMessage(0);
					break;
			}
			break;

		case WM_ERASEBKGND:
			return 1;

		case WM_CLOSE:
		case WM_DESTROY:
			PostQuitMessage(0);
			break;

		default:
			return DefWindowProc(hwnd, msg, wParam, lParam);
			break;
	}

	return 0;
}


LRESULT CALLBACK DialogProc(HWND Dlg,UINT message,WPARAM wParam,LPARAM lParam)
{
     HWND hlores,hhires,hwindow,hfullscreen,hstart,hquitter;
     switch(message)
     {
     case WM_INITDIALOG:
     {
             // Creer les boutons, le cadre et la zone de texte
			 hlores = CreateWindow("BUTTON","320x240 (original)",WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON | WS_GROUP,80-26,20,150,15, Dlg, (HMENU)BtLores, hInstance,0);
			 hhires = CreateWindow("BUTTON","640x480 (doubled)",WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON,80-26,50,150,15, Dlg, (HMENU)BtHires, hInstance,0);
			 hwindow = CreateWindow("BUTTON","Windowed",WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON | WS_GROUP,260-26,20,150,15, Dlg, (HMENU)BWindow, hInstance,0);
			 hfullscreen = CreateWindow("BUTTON","FullScreen",WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON,260-26,50,150,15, Dlg, (HMENU)BFullsc, hInstance,0);
             hstart = CreateWindow("BUTTON", "Start", WS_CHILD | WS_VISIBLE , 80-26, 80,80, 30, Dlg, (HMENU)BtStart, hInstance, 0);
             hquitter = CreateWindow("BUTTON", "Cancel", WS_CHILD | WS_VISIBLE , 260-26, 80,80, 30, Dlg, (HMENU)Quitter, hInstance, 0);
			// active boutons
			 SendMessage(GetDlgItem( Dlg, BtLores),BM_SETCHECK,ZOOM==1?BST_CHECKED:BST_UNCHECKED,0);
			 SendMessage(GetDlgItem( Dlg, BtHires),BM_SETCHECK,ZOOM==2?BST_CHECKED:BST_UNCHECKED,0);
			 SendMessage(GetDlgItem( Dlg, BWindow),BM_SETCHECK,!fullscreen?BST_CHECKED:BST_UNCHECKED,0);
			 SendMessage(GetDlgItem( Dlg, BFullsc),BM_SETCHECK,fullscreen?BST_CHECKED:BST_UNCHECKED,0);
             return 0;
     }
     case WM_CLOSE: //clic sur la croix de fermeture
	{
		butquit=TRUE;
        EndDialog(Dlg,0);
	}

    case WM_COMMAND:    
    {
         switch(LOWORD(wParam))
         {
			case BtLores:
			{
				ZOOM=1;
				break;
			}

			case BtHires:
			{
				ZOOM=2;
				break;
			}

			case BWindow:
			{
				fullscreen=FALSE;
				break;
			}

			case BFullsc:
			{
				fullscreen=TRUE;
				break;
			}

			case BtStart:
			{
				butquit=FALSE;
				EndDialog(Dlg,0);
				break;
			}
            case Quitter: //clic sur le bouton Quitter
            {
				butquit=TRUE;
				EndDialog(Dlg,0);
            }
         }
        }   
        break;
     }
return 0;
}